#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use psfp;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 



##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "domailing") { &domailing; }
if ($q->param('fct') eq "do_send") { &do_send; }

##################################################################################




sub do_send
{

$st = $q->param('st');
if ($st eq "") { $st = 0; }

$emailnr = $q->param('emailnr');
$subscribed_only = $q->param('subscribed_only');

$prevent_dupl = $q->param('prevent_dupl');
$subscribed_only = $q->param('subscribed_only');
$exclude_prem = $q->param('exclude_prem');


### SET UP SEND

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


if ($prevent_dupl eq "Y") { $groupsql = " GROUP BY email"; }
if ($subscribed_only eq "Y") { $subscribe_sql = " AND (subscribed = 'Y') "; }
if ($exclude_prem eq "Y") 
		{
		$now = time();
		$exclude_prem_sql = " AND (subs_expire < '$now') AND ((premium < '1') OR (premium IS NULL))"; 
		}

### IF SELECTED CATEGORIES

$catcrit = $q->param('catcrit');

if ($catcrit ne "")
	{
	@all_cids = split (/,/, $catcrit);
		
		foreach $citem (@all_cids)
			{
				if ($citem > 0)
					{
					$selcats = $selcats . " (cid = '$citem') OR";
					}
			}
	}

if ($selcats ne "") 
	{
	$selcats = substr($selcats, 0, length($selcats) - 2);
	$selcats = " AND ($selcats) "; 
	}


$sql = "SELECT * FROM links WHERE ((email IS NOT NULL) AND (email != '')) $selcats $exclude_prem_sql $subscribe_sql $groupsql ORDER BY email LIMIT $st, $emailnr";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}


### GET EMAIL MSG

$emailmsg = acs::get_file_contents("$data_dir/tmp/links.eml");
@emlines = split(/\n/, $emailmsg);

$from_email = $emlines[0];
$from_name = $emlines[1];
$subject = $emlines[2];

$rc = 0;
foreach $item (@emlines)
	{
	if ($rc > 2)
		{
		$email_message = $email_message . $item . "\n";
		}
		$rc++;
	}


#### SEND MAILS

	while ( @row = $sth->fetchrow() )
		{
		$tmpmsg = $email_message;

		$tmpmsg =~ s/%%title%%/$row[2]/i;
		$tmpmsg =~ s/%%description%%/$row[3]/i;
		$tmpmsg =~ s/%%keywords%%/$row[4]/i;
		$tmpmsg =~ s/%%url%%/$row[5]/i;
		$tmpmsg =~ s/%%name%%/$row[8]/i;
		
		
		if ($row[10] eq "") {$row[10] = "NA"; }
		$tmpmsg =~ s/%%rating%%/$row[10]/i;
		
		if ($row[11] eq "") { $row[11] = 0; }
		$tmpmsg =~ s/%%votes%%/$row[11]/i;
		
		if ($row[12] eq "") { $row[12] = 0; }
		$tmpmsg =~ s/%%hits%%/$row[12]/i;
		
		$tmpmsg =~ s/%%modify_password%%/$row[22]/i;
		
		#$modifylink = "$script_url/gethtml2.cgi?id=$row[0]";
		#$tmpmsg =~ s/%%link_to_modify_page%%/$modifylink/i;
		#$ratingcode = "$script_url/gethtml2.cgi?id=$row[0]";
		#$tmpmsg =~ s/%%link_to_rating_code%%/$row[2]/i;
		
		### SEND EMAIL
		acs::send_email ($from_name, $from_email, $row[9], $subject, $tmpmsg);
		
		$currsend = $currsend . "$row[9] - $row[2]<BR>";
		
		$found_row = "true";
		}

$sth->finish;
$dbh->disconnect;


$st = $st + $emailnr;




#### IF FINISHED
if ($found_row ne "true")
	{
	

$hbox = acs::get_heading_box("$web_url/ic_email2.gif", "Send Complete", qq[
You may <a href="javascript:onClick=window.close()">close</a> this window or <a href="$admin_url/admin33.cgi">click here to continue</a>
]);

	

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

exit;
	
	}


### GET PERCENTBAR

$oldst = $st - $emailnr;

$total = $q->param('total');
$perc = ($oldst / $total) * 100;
$perc = sprintf("%5.2f",$perc);
$barwidth = $perc . "%";

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin64.cgi?fct=do_send&emailnr=$emailnr&st=$st&subscribed_only=$subscribed_only&total=$total&prevent_dupl=$prevent_dupl&exclude_prem=$exclude_prem&catcrit=$catcrit">
</head>
<body>

<table border="0" cellpadding="5" cellspacing="0" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="12%"><strong><img src="$web_url/working.gif"> </strong></td>
    <td width="12%"><p align="center"><strong>$perc% Complete </strong></td>
    <td width="88%"><table width="$perc%" border="0">
      <tr>
        <td height="30" background="$web_url/bar.gif"></td>
      </tr>
    </table>
    </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
    <td width="99%"></td>
  </tr>
</table>

<blockquote>
<p><b>Sending Mail To: </b><br>
$currsend </p>
</blockquote>

</body>
</html>
];


}







sub domailing
{


### CHECK FOR ERRORS

$from_email = $q->param('from_email');
$from_name = $q->param('from_name');
$subject = $q->param('subject');
$message = $q->param('message');
$emailnr = $q->param('emailnr');
$test_email = $q->param('test_email');

$prevent_dupl = $q->param('prevent_dupl');
$subscribed_only = $q->param('subscribed_only');
$exclude_prem = $q->param('exclude_prem');



if ($from_email eq "")  { acs::problem_popup("You have to provide an email address where the email is being sent from."); exit;}
if ($from_name eq "")  { acs::problem_popup("You have to provide a name from who the email is being sent."); exit;}
if ($subject eq "")  { acs::problem_popup("You have to provide a subject for the email message."); exit;}
if ($message eq "")  { acs::problem_popup("You have to provide a message for the email message."); exit;}



#### SEND TEST EMAIL IF CHOSEN TO SEND TEST EMAIL
if ($q->param('testbut') eq "   Send Test Email    ") { &send_test_email; }

if ($emailnr < 1) { acs::problem_popup("You have to provide a number of how many messages will be sent at a time."); exit;}



#### CREATE TEMP DIR WHERE WE WILL STORE TEMP DATA
$temp_dir = "$data_dir/tmp";
if ((-e $temp_dir) < 1) {
mkdir ($temp_dir, $default_permissions);
chmod($default_permissions,"$upload_dir","$upload_dir"); }


### RECORD EMAIL MSG THAT WE WANT TO SEND
open (EML, "> $data_dir/tmp/links.eml");
	print EML $from_email . "\n";
	print EML $from_name . "\n";
	print EML $subject . "\n";
	print EML $message . "\n";
close (EML);


#### COUNT HOW MANY EMAILS WE ARE GOING TO SEND FOR PERCENTAGE BAR

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

if ($prevent_dupl eq "Y") { $groupsql = " GROUP BY email"; }
if ($subscribed_only eq "Y") { $subscribe_sql = " AND (subscribed = 'Y') "; }

if ($exclude_prem eq "Y") 
		{
		$now = time();
		$exclude_prem_sql = " AND (subs_expire < '$now') AND ((premium < '1') OR (premium IS NULL))"; 
		}


### IF SENDING TO SELECTED CATEGORIES

$catcrit = $q->param('related_categories');
$catcrit =~ s/ //g;

if ($catcrit ne "")
	{
	@all_cids = split (/,/, $catcrit);
		
		foreach $citem (@all_cids)
			{
				if ($citem > 0)
					{
					$selcats = $selcats . " (cid = '$citem') OR";
					}
			}
	}

if ($selcats ne "") 
	{
	$selcats = substr($selcats, 0, length($selcats) - 2);
	$selcats = " AND ($selcats) "; 
	}


$sql = "SELECT lnkid FROM links WHERE ((email IS NOT NULL) AND (email != '')) $selcats $exclude_prem_sql $subscribe_sql $groupsql ORDER BY email";
#print "--> $sql <BR>";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$total = 1;

	while ( @row = $sth->fetchrow() )
		{
		$total++;
		}

$sth->finish;
$dbh->disconnect;


#print "<BR>--> $total <BR>"; exit;



print qq[
<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin64.cgi?fct=do_send&amp;emailnr=$emailnr&amp;subscribed_only=$subscribed_only&amp;total=$total&prevent_dupl=$prevent_dupl&exclude_prem=$exclude_prem&catcrit=$catcrit">
</head>

<body>

<table border="0" cellpadding="5" cellspacing="0" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="112%"><font face="Verdana" size="1"><strong><img src="$web_url/working.gif"></strong></font></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

<p><span class="normaltext">Preparing to Send Mail... </span></p>
</body>
</html>
];



}












sub send_test_email
{

if ($test_email eq "")  { acs::problem_popup("You have to provide a an email address where the test email will be sent to."); exit;}

$message2 = $message;

$message =~ s/%%title%%/The Link Title/i;
$message =~ s/%%description%%/Link Description/i;
$message =~ s/%%keywords%%/Some, Keywords/i;
$message =~ s/%%url%%/http:\/\/www\.just\.testing\.com/i;
$message =~ s/%%name%%/John Doe/i;
$message =~ s/%%rating%%/10/i;
$message =~ s/%%votes%%/55/i;
$message =~ s/%%hits%%/1000/i;
$message =~ s/%%modify_password%%/SomePassword/i;


acs::send_email ($from_name, $from_email, $test_email, $subject, $message);

$prevent_dupl = $q->param('prevent_dupl');
$subscribed_only = $q->param('subscribed_only');
$exclude_prem = $q->param('exclude_prem');



$hbox = acs::get_heading_box("$web_url/ic_email2.gif", "Test Email Sent", qq[
Note that if you used variables inside the email then it will be replaced by fictional text. (For example purposes)
<BR>

<form method="POST" action="$admin_url/admin64.cgi">
  <input type="hidden" name="from_email1" value="$from_email"><input type="hidden"
  name="from_name1" value="$from_name"><input type="hidden" name="subject1" value="$subject"><input
  type="hidden" name="message1" value="$message2"><input type="hidden" name="emailnr1"
  value="$emailnr"><input type="hidden" name="subscribed_only1" value="$subscribed_only"><input
  type="hidden" name="prevent_dupl1" value="$prevent_dupl"><input type="hidden"
  name="exclude_prem1" value="$exclude_prem"><p><input type="submit"
  value="Click here to continue" name="B1"> </p>
</form>

]);




print qq[
<html>
<head>
<title>PowerSeek Mailer</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>

];

exit;

}







sub start
{

$from_email1 = $q->param('from_email1');
$from_name1 = $q->param('from_name1');
$subject1 = $q->param('subject1');
$message1 = $q->param('message1');
$emailnr1 = $q->param('emailnr1'); if ($emailnr1 eq "") { $emailnr1 = 20; }

$subscribed_only1 = $q->param('subscribed_only1');
if ($subscribed_only1 eq "Y")
	{
	$subschecked = "checked";
	}

$prevent_dupl = $q->param('prevent_dupl1');
if ($prevent_dupl eq "Y")
	{
	$prevent_dupl_checked = "checked";
	}

$exclude_prem = $q->param('exclude_prem1');
if ($exclude_prem eq "Y")
	{
	$exclude_prem_checked = "checked";
	}



$hbox = acs::get_heading_box("$web_url/ic_email2.gif", "Send Email to Link Owners", qq[
This section enables you to send email to link owners. This means that email will be sent to all email addresses supplied with links.
<BR>
<a href="$admin_url/admin33.cgi"><b>Go Back</b></a>
]);

$helpb = acs::quick_help("Variables Available For Use In This Email ",qq[
<p><strong>Variables Available for Use in Email Message: <br>
</strong>You may use the variables (words) as listed below inside the email message. It
will be replaced by for examples the names and details of the users you are mailing. </p>

<p><strong>%%title%% <br>
</strong>This will be replaced by the title of the link. </p>

<p><strong>%%description%% <br>
</strong>Replaced by the description of the link. </p>

<p><strong>%%keywords%% <br>
</strong>Replaced by the keywords of the link. </p>

<p><strong>%%url%% <br>
</strong>Replaced by the URL of the link. </p>

<p><strong>%%name%% <br>
</strong>Replaced by the name of the contact person for the link. </p>

<p><strong>%%rating%% <br>
</strong>Replaced by the rating of the link. </p>

<p><strong>%%votes%% <br>
</strong>Replaced by the votes the link has received. </p>

<p><strong>%%hits%% <br>
</strong>Replaced by the hits (clicks) the link has received. </p>
]); 

 







print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">

<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(400,0);
      myWindow.focus();

    }
 // End Hide -->
 </script>


</head>
<body>
$hbox



<form method="POST" action="$admin_url/admin64.cgi" name="addu">
  <input type="hidden" name="fct" value="domailing"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#DADADA">
    <tr>
      <td colspan="2" background="$web_url/bar6.gif" class="normaltext"><strong>Email Message: </strong></td>
    </tr>
    <tr>
      <td width="30%" valign="top" bgcolor="#FFFFFF" class="normaltext">From Email Address: </td>
      <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="from_email"
      size="60" value="$from_email1" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="30%" valign="top" bgcolor="#FFFFFF" class="normaltext">From Name: </td>
      <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="from_name"
      size="60" value="$from_name1" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="30%" valign="top" bgcolor="#FFFFFF" class="normaltext">Subject: </td>
      <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="subject"
      size="60" value="$subject1" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="30%" valign="top" bgcolor="#FFFFFF" class="normaltext">Message:</td>
      <td width="70%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="18" name="message"
      cols="63" style="width:100%">$message1</textarea> </td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox"
      name="subscribed_only" value="Y" $subschecked> Only send email to link owners who ticked
      the subcribe box when they made a submission. </td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox"
      name="exclude_prem" value="Y" $exclude_prem_checked> Exclude Premium Links in Mailing </td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox"
      name="prevent_dupl" value="Y" $prevent_dupl_checked> Prevent duplicate emails </td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF" class="normaltext">Number of emails to send at a time: </td>
      <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="emailnr"
      size="11" value="$emailnr1"> <br>
      Only a certain amount of email messages will be sent at a time not to overload your mail
      server. </td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF" class="normaltext">Only send email to link owners of
      these categories:</td>
      <td width="70%" bgcolor="#FFFFFF" class="normaltext">
      <input type="text" name="related_categories" size="50" style="width:80%"> 
      <a href="$admin_url/admin67.cgi" onclick="popup('$admin_url/admin67.cgi?fct=related',750,600);return false;"><b>Browser (Get Ids)</b></a>
      <br>
      Leave blank to send email to link owners of all categories. Enter the category IDs
      seperated by comma's in the box above. <br>
      Click the 'Browser' button to browse categories and assign IDs.</td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="   Send   " name="sendbut"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DADADA">
    <tr>
      <td width="766" colspan="2" background="$web_url/bar6.gif" class="normaltext"><strong>Send
      a Test Email </strong></td>
    </tr>
    <tr>
      <td colspan="2" bgcolor="#FFFFFF" class="normaltext">You can send the email message above
      to the email address below. This enables you to see how the message is going to look like
      when link owners receive it. </td>
    </tr>
    <tr>
      <td width="30%" valign="top" bgcolor="#FFFFFF" class="normaltext">Send it to email
      Address: </td>
      <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="test_email"
      size="60"></td>
    </tr>
    <tr>
      <td width="30%" valign="top" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="70%" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="   Send Test Email    " name="testbut"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
  <p>$helpb </p>
</form>



</body>
</html>

];


}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

